Index: django/contrib/localflavor/uk/uk_regions.py
===================================================================
--- django/contrib/localflavor/uk/uk_regions.py	(revisión: 7554)
+++ django/contrib/localflavor/uk/uk_regions.py	(copia de trabajo)
@@ -5,7 +5,7 @@
     Welsh regions: http://en.wikipedia.org/wiki/Preserved_counties_of_Wales
     Scottish regions: http://en.wikipedia.org/wiki/Regions_and_districts_of_Scotland
 """
-from django.utils.translation import ugettext as _
+from django.utils.translation import ugettext_lazy as _
 
 ENGLAND_REGION_CHOICES = (
     ("Bedfordshire", _("Bedfordshire")),
Index: django/contrib/localflavor/uk/forms.py
===================================================================
--- django/contrib/localflavor/uk/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/uk/forms.py	(copia de trabajo)
@@ -6,7 +6,7 @@
 
 from django.newforms.fields import CharField, Select
 from django.newforms import ValidationError
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 
 class UKPostcodeField(CharField):
     """
@@ -18,7 +18,7 @@
     The value is uppercased and a space added in the correct place, if required.
     """
     default_error_messages = {
-        'invalid': ugettext(u'Enter a valid postcode.'),
+        'invalid': _(u'Enter a valid postcode.'),
     }
     outcode_pattern = '[A-PR-UWYZ]([0-9]{1,2}|([A-HIK-Y][0-9](|[0-9]|[ABEHMNPRVWXY]))|[0-9][A-HJKSTUW])'
     incode_pattern = '[0-9][ABD-HJLNP-UW-Z]{2}'
Index: django/contrib/localflavor/ca/forms.py
===================================================================
--- django/contrib/localflavor/ca/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/ca/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
 from django.newforms.util import smart_unicode
-from django.utils.translation import gettext, ugettext
+from django.utils.translation import ugettext_lazy as _
 import re
 
 phone_digits_re = re.compile(r'^(?:1-?)?(\d{3})[-\.]?(\d{3})[-\.]?(\d{4})$')
@@ -14,7 +14,7 @@
 class CAPostalCodeField(RegexField):
     """Canadian postal code field."""
     default_error_messages = {
-        'invalid': gettext(u'Enter a postal code in the format XXX XXX.'),
+        'invalid': _(u'Enter a postal code in the format XXX XXX.'),
     }
 
     def __init__(self, *args, **kwargs):
@@ -85,7 +85,7 @@
              See: http://en.wikipedia.org/wiki/Social_Insurance_Number
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid Canadian Social Insurance number in XXX-XXX-XXX format.'),
+        'invalid': _('Enter a valid Canadian Social Insurance number in XXX-XXX-XXX format.'),
     }
 
     def clean(self, value):
Index: django/contrib/localflavor/us/forms.py
===================================================================
--- django/contrib/localflavor/us/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/us/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
 from django.utils.encoding import smart_unicode
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 import re
 
 phone_digits_re = re.compile(r'^(?:1-?)?(\d{3})[-\.]?(\d{3})[-\.]?(\d{4})$')
@@ -13,7 +13,7 @@
 
 class USZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a zip code in the format XXXXX or XXXXX-XXXX.'),
+        'invalid': _('Enter a zip code in the format XXXXX or XXXXX-XXXX.'),
     }
 
     def __init__(self, *args, **kwargs):
@@ -51,7 +51,7 @@
           1962 promotional number).
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid U.S. Social Security number in XXX-XX-XXXX format.'),
+        'invalid': _('Enter a valid U.S. Social Security number in XXX-XX-XXXX format.'),
     }
 
     def clean(self, value):
Index: django/contrib/localflavor/de/forms.py
===================================================================
--- django/contrib/localflavor/de/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/de/forms.py	(copia de trabajo)
@@ -4,14 +4,14 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 import re
 
 id_re = re.compile(r"^(?P<residence>\d{10})(?P<origin>\w{1,3})[-\ ]?(?P<birthday>\d{7})[-\ ]?(?P<validity>\d{7})[-\ ]?(?P<checksum>\d{1})$")
 
 class DEZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a zip code in the format XXXXX.'),
+        'invalid': _('Enter a zip code in the format XXXXX.'),
     }
     def __init__(self, *args, **kwargs):
         super(DEZipCodeField, self).__init__(r'^\d{5}$',
@@ -38,7 +38,7 @@
     Algorithm is documented at http://de.wikipedia.org/wiki/Personalausweis
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid German identity card number in XXXXXXXXXXX-XXXXXXX-XXXXXXX-X format.'),
+        'invalid': _('Enter a valid German identity card number in XXXXXXXXXXX-XXXXXXX-XXXXXXX-X format.'),
     }
 
     def has_valid_checksum(self, number):
Index: django/contrib/localflavor/ch/forms.py
===================================================================
--- django/contrib/localflavor/ch/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/ch/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
 from django.utils.encoding import smart_unicode
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 import re
 
 id_re = re.compile(r"^(?P<idnumber>\w{8})(?P<pos9>(\d{1}|<))(?P<checksum>\d{1})$")
@@ -13,7 +13,7 @@
 
 class CHZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a zip code in the format XXXX.'),
+        'invalid': _('Enter a zip code in the format XXXX.'),
     }
 
     def __init__(self, *args, **kwargs):
@@ -61,7 +61,7 @@
     Algorithm is documented at http://adi.kousz.ch/artikel/IDCHE.htm
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid Swiss identity or passport card number in X1234567<0 or 1234567890 format.'),
+        'invalid': _('Enter a valid Swiss identity or passport card number in X1234567<0 or 1234567890 format.'),
     }
 
     def has_valid_checksum(self, number):
Index: django/contrib/localflavor/fi/forms.py
===================================================================
--- django/contrib/localflavor/fi/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/fi/forms.py	(copia de trabajo)
@@ -5,11 +5,11 @@
 import re
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 
 class FIZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a zip code in the format XXXXX.'),
+        'invalid': _('Enter a zip code in the format XXXXX.'),
     }
     def __init__(self, *args, **kwargs):
         super(FIZipCodeField, self).__init__(r'^\d{5}$',
@@ -25,7 +25,7 @@
 
 class FISocialSecurityNumber(Field):
     default_error_messages = {
-        'invalid': ugettext('Enter a valid Finnish social security number.'),
+        'invalid': _('Enter a valid Finnish social security number.'),
     }
 
     def clean(self, value):
Index: django/contrib/localflavor/cl/forms.py
===================================================================
--- django/contrib/localflavor/cl/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/cl/forms.py	(copia de trabajo)
@@ -4,7 +4,7 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import RegexField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 from django.utils.encoding import smart_unicode
 
 
@@ -26,9 +26,9 @@
     https://palena.sii.cl/cvc/dte/ee_empresas_emisoras.html
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid Chilean RUT.'),
-        'strict': ugettext('Enter a valid Chilean RUT. The format is XX.XXX.XXX-X.'),
-        'checksum': ugettext('The Chilean RUT is not valid.'),
+        'invalid': _('Enter a valid Chilean RUT.'),
+        'strict': _('Enter a valid Chilean RUT. The format is XX.XXX.XXX-X.'),
+        'checksum': _('The Chilean RUT is not valid.'),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/ar/forms.py
===================================================================
--- django/contrib/localflavor/ar/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/ar/forms.py	(copia de trabajo)
@@ -6,7 +6,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import RegexField, CharField, Select, EMPTY_VALUES
 from django.utils.encoding import smart_unicode
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 
 class ARProvinceSelect(Select):
     """
@@ -24,7 +24,7 @@
     See http://www.correoargentino.com.ar/consulta_cpa/home.php
     """
     default_error_messages = {
-        'invalid': ugettext("Enter a postal code in the format NNNN or ANNNNAAA."),
+        'invalid': _("Enter a postal code in the format NNNN or ANNNNAAA."),
     }
 
     def __init__(self, *args, **kwargs):
@@ -46,8 +46,8 @@
     A field that validates 'Documento Nacional de Identidad' (DNI) numbers.
     """
     default_error_messages = {
-        'invalid': ugettext("This field requires only numbers."),
-        'max_digits': ugettext("This field requires 7 or 8 digits."),
+        'invalid': _("This field requires only numbers."),
+        'max_digits': _("This field requires 7 or 8 digits."),
     }
 
     def __init__(self, *args, **kwargs):
@@ -76,8 +76,8 @@
     CUIT is of the form XX-XXXXXXXX-V. The last digit is a check digit.
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid CUIT in XX-XXXXXXXX-X or XXXXXXXXXXXX format.'),
-        'checksum': ugettext("Invalid CUIT."),
+        'invalid': _('Enter a valid CUIT in XX-XXXXXXXX-X or XXXXXXXXXXXX format.'),
+        'checksum': _("Invalid CUIT."),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/br/forms.py
===================================================================
--- django/contrib/localflavor/br/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/br/forms.py	(copia de trabajo)
@@ -6,7 +6,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, CharField, Select, EMPTY_VALUES
 from django.utils.encoding import smart_unicode
-from django.utils.translation import ugettext as _
+from django.utils.translation import ugettext_lazy as _
 import re
 
 try:
Index: django/contrib/localflavor/pe/forms.py
===================================================================
--- django/contrib/localflavor/pe/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/pe/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import RegexField, CharField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 
 class PEDepartmentSelect(Select):
     """
@@ -20,8 +20,8 @@
     A field that validates `Documento Nacional de IdentidadŽ (DNI) numbers.
     """
     default_error_messages = {
-        'invalid': ugettext("This field requires only numbers."),
-        'max_digits': ugettext("This field requires 8 digits."),
+        'invalid': _("This field requires only numbers."),
+        'max_digits': _("This field requires 8 digits."),
     }
 
     def __init__(self, *args, **kwargs):
@@ -48,8 +48,8 @@
     the form XXXXXXXXXXX.
     """
     default_error_messages = {
-        'invalid': ugettext("This field requires only numbers."),
-        'max_digits': ugettext("This field requires 11 digits."),
+        'invalid': _("This field requires only numbers."),
+        'max_digits': _("This field requires 11 digits."),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/au/forms.py
===================================================================
--- django/contrib/localflavor/au/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/au/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
 from django.newforms.util import smart_unicode
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 import re
 
 PHONE_DIGITS_RE = re.compile(r'^(\d{10})$')
@@ -13,7 +13,7 @@
 class AUPostCodeField(RegexField):
     """Australian post code field."""
     default_error_messages = {
-        'invalid': ugettext('Enter a 4 digit post code.'),
+        'invalid': _('Enter a 4 digit post code.'),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/es/forms.py
===================================================================
--- django/contrib/localflavor/es/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/es/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import RegexField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext as _
+from django.utils.translation import ugettext_lazy as _
 import re
 
 class ESPostalCodeField(RegexField):
Index: django/contrib/localflavor/fr/forms.py
===================================================================
--- django/contrib/localflavor/fr/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/fr/forms.py	(copia de trabajo)
@@ -5,14 +5,14 @@
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
 from django.utils.encoding import smart_unicode
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 import re
 
 phone_digits_re = re.compile(r'^0\d(\s|\.)?(\d{2}(\s|\.)?){3}\d{2}$')
 
 class FRZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a zip code in the format XXXXX.'),
+        'invalid': _('Enter a zip code in the format XXXXX.'),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/nl/forms.py
===================================================================
--- django/contrib/localflavor/nl/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/nl/forms.py	(copia de trabajo)
@@ -6,7 +6,7 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import Field, Select, EMPTY_VALUES
-from django.utils.translation import ugettext as _
+from django.utils.translation import ugettext_lazy as _
 from django.utils.encoding import smart_unicode
 
 pc_re = re.compile('^\d{4}[A-Z]{2}$')
Index: django/contrib/localflavor/jp/forms.py
===================================================================
--- django/contrib/localflavor/jp/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/jp/forms.py	(copia de trabajo)
@@ -4,7 +4,7 @@
 
 from django.core import validators
 from django.newforms import ValidationError
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 from django.newforms.fields import RegexField, Select
 
 class JPPostalCodeField(RegexField):
@@ -14,7 +14,7 @@
     Accepts 7 digits, with or without a hyphen.
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a postal code in the format XXXXXXX or XXX-XXXX.'),
+        'invalid': _('Enter a postal code in the format XXXXXXX or XXX-XXXX.'),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/is_/forms.py
===================================================================
--- django/contrib/localflavor/is_/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/is_/forms.py	(copia de trabajo)
@@ -5,7 +5,7 @@
 from django.newforms import ValidationError
 from django.newforms.fields import RegexField, EMPTY_VALUES
 from django.newforms.widgets import Select
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 from django.utils.encoding import smart_unicode
 
 class ISIdNumberField(RegexField):
@@ -14,8 +14,8 @@
     of Iceland has.
     """
     default_error_messages = {
-        'invalid': ugettext('Enter a valid Icelandic identification number. The format is XXXXXX-XXXX.'),
-        'checksum': ugettext(u'The Icelandic identification number is not valid.'),
+        'invalid': _('Enter a valid Icelandic identification number. The format is XXXXXX-XXXX.'),
+        'checksum': _(u'The Icelandic identification number is not valid.'),
     }
 
     def __init__(self, *args, **kwargs):
Index: django/contrib/localflavor/pl/forms.py
===================================================================
--- django/contrib/localflavor/pl/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/pl/forms.py	(copia de trabajo)
@@ -6,7 +6,7 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import Select, RegexField
-from django.utils.translation import ugettext as _
+from django.utils.translation import ugettext_lazy as _
 
 class PLVoivodeshipSelect(Select):
     """
Index: django/contrib/localflavor/no/forms.py
===================================================================
--- django/contrib/localflavor/no/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/no/forms.py	(copia de trabajo)
@@ -5,11 +5,11 @@
 import re, datetime
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 
 class NOZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a zip code in the format XXXX.'),
+        'invalid': _('Enter a zip code in the format XXXX.'),
     }
 
     def __init__(self, *args, **kwargs):
@@ -30,7 +30,7 @@
     Algorithm is documented at http://no.wikipedia.org/wiki/Personnummer
     """
     default_error_messages = {
-        'invalid': ugettext(u'Enter a valid Norwegian social security number.'),
+        'invalid': _(u'Enter a valid Norwegian social security number.'),
     }
 
     def clean(self, value):
Index: django/contrib/localflavor/it/forms.py
===================================================================
--- django/contrib/localflavor/it/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/it/forms.py	(copia de trabajo)
@@ -4,14 +4,14 @@
 
 from django.newforms import ValidationError
 from django.newforms.fields import Field, RegexField, Select, EMPTY_VALUES
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 from django.utils.encoding import smart_unicode
 from django.contrib.localflavor.it.util import ssn_check_digit, vat_number_check_digit
 import re
 
 class ITZipCodeField(RegexField):
     default_error_messages = {
-        'invalid': ugettext('Enter a valid zip code.'),
+        'invalid': _('Enter a valid zip code.'),
     }
     def __init__(self, *args, **kwargs):
         super(ITZipCodeField, self).__init__(r'^\d{5}$',
@@ -40,7 +40,7 @@
     'Informazioni sulla codificazione delle persone fisiche'.
     """
     default_error_messages = {
-        'invalid': ugettext(u'Enter a valid Social Security number.'),
+        'invalid': _(u'Enter a valid Social Security number.'),
     }
 
     def __init__(self, *args, **kwargs):
@@ -65,7 +65,7 @@
     A form field that validates Italian VAT numbers (partita IVA).
     """
     default_error_messages = {
-        'invalid': ugettext(u'Enter a valid VAT number.'),
+        'invalid': _(u'Enter a valid VAT number.'),
     }
 
     def clean(self, value):
Index: django/contrib/localflavor/sk/forms.py
===================================================================
--- django/contrib/localflavor/sk/forms.py	(revisión: 7554)
+++ django/contrib/localflavor/sk/forms.py	(copia de trabajo)
@@ -3,7 +3,7 @@
 """
 
 from django.newforms.fields import Select, RegexField
-from django.utils.translation import ugettext
+from django.utils.translation import ugettext_lazy as _
 
 class SKRegionSelect(Select):
     """
@@ -27,7 +27,7 @@
     Valid form is XXXXX or XXX XX, where X represents integer.
     """
     default_error_messages = {
-        'invalid': ugettext(u'Enter a postal code in the format XXXXX or XXX XX.'),
+        'invalid': _(u'Enter a postal code in the format XXXXX or XXX XX.'),
     }
 
     def __init__(self, *args, **kwargs):